---
title: Array.prototype.findIndex()
slug: Web/JavaScript/Reference/Global_Objects/Array/findIndex
tags:
  - Array
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - Reference
  - polyfill
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <code><strong>findIndex()</strong></code> method returns the <strong>index</strong> of the first element in the array <strong>that satisfies the provided testing function</strong>. Otherwise, it returns <code>-1</code>, indicating that no element passed the test.</span></p>

<div>{{EmbedInteractiveExample("pages/js/array-findindex.html","shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>See also the {{jsxref("Array.find", "find()")}} method, which returns the <strong>value</strong> of an array element, instead of its index.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>arr</var>.findIndex(<var>callback</var>( <var>element</var>[, <var>index</var>[, <var>array</var>]] )[, <var>thisArg</var>])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>
 <p>A function to execute on each value in the array until the function returns <code>true</code>, indicating that the satisfying element was found.</p>

 <p>It takes three arguments:</p>

 <dl>
  <dt><code><var>element</var></code></dt>
  <dd>The current element being processed in the array.</dd>
  <dt><code><var>index</var></code> {{optional_inline}}</dt>
  <dd>The index of the current element being processed in the array.</dd>
  <dt><code><var>array</var></code> {{optional_inline}}</dt>
  <dd>The array <code>findIndex()</code> was called upon.</dd>
 </dl>
 </dd>
 <dt><code><var>thisArg</var></code> {{optional_inline}}</dt>
 <dd>Optional object to use as <code>this</code> when executing <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The index of the first element in the array that passes the test. Otherwise, <code>-1</code>.</p>

<h2 id="Description">Description</h2>

<p>The <code>findIndex()</code> method executes the <code><var>callback</var></code> function once for every index in the array until it finds the one where <code><var>callback</var></code> returns a {{Glossary("truthy")}} value.</p>

<p>If such an element is found, <code>findIndex()</code> immediately returns the element's index. If <code><var>callback</var></code> never returns a truthy value (or the array's <code>length</code> is <code>0</code>), <code>findIndex()</code> returns <code>-1</code>.</p>

<div class="notecard note">
<p><strong>Edge case alert:</strong> Unlike other array methods such as {{jsxref("Array.some()")}}, <code><var>callback</var></code> is run even for indexes with unassigned values.</p>
</div>

<p><code><var>callback</var></code> is invoked with three arguments:</p>

<ol>
 <li>The value of the element</li>
 <li>The index of the element</li>
 <li>The Array object being traversed</li>
</ol>

<p>If a <code><var>thisArg</var></code> parameter is passed to <code>findIndex()</code>, it will be used as the <code>this</code> inside each invocation of the <code><var>callback</var></code>. If it is not provided, then {{jsxref("undefined")}} is used.</p>

<p>The range of elements processed by <code>findIndex()</code> is set before the first invocation of <code><var>callback</var></code>. <code><var>callback</var></code> will not process the elements appended to the array after the call to <code>findIndex()</code> begins. If an existing, unvisited element of the array is changed by <code><var>callback</var></code>, its value passed to the <code><var>callback</var></code> will be the value at the time <code>findIndex()</code> visits the element's index.</p>

<p>Elements that are <a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">deleted</a> are still visited.</p>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush: js">// https://tc39.github.io/ecma262/#sec-array.prototype.findindex
if (!Array.prototype.findIndex) {
  Object.defineProperty(Array.prototype, 'findIndex', {
    value: function(predicate) {
     // 1. Let O be ? ToObject(this value).
      if (this == null) {
        throw new TypeError('"this" is null or not defined');
      }

      var o = Object(this);

      // 2. Let len be ? ToLength(? Get(O, "length")).
      var len = o.length &gt;&gt;&gt; 0;

      // 3. If IsCallable(predicate) is false, throw a TypeError exception.
      if (typeof predicate !== 'function') {
        throw new TypeError('predicate must be a function');
      }

      // 4. If thisArg was supplied, let T be thisArg; else let T be undefined.
      var thisArg = arguments[1];

      // 5. Let k be 0.
      var k = 0;

      // 6. Repeat, while k &lt; len
      while (k &lt; len) {
        // a. Let Pk be ! ToString(k).
        // b. Let kValue be ? Get(O, Pk).
        // c. Let testResult be ToBoolean(? Call(predicate, T, « kValue, k, O »)).
        // d. If testResult is true, return k.
        var kValue = o[k];
        if (predicate.call(thisArg, kValue, k, o)) {
          return k;
        }
        // e. Increase k by 1.
        k++;
      }

      // 7. Return -1.
      return -1;
    },
    configurable: true,
    writable: true
  });
}
</pre>

<p>If you need to support truly obsolete JavaScript engines that do not support {{jsxref("Object.defineProperty")}}, it is best not to polyfill <code>Array.prototype</code> methods at all, as you cannot make them non-enumerable.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Find_the_index_of_a_prime_number_in_an_array">Find the index of a prime number in an array</h3>

<p>The following example returns the index of the first element in the array that is a prime number, or <code>-1</code> if there is no prime number.</p>

<pre class="brush: js">function isPrime(num) {
  for (let i = 2; num &gt; i; i++) {
    if (num % i == 0) {
      return false;
    }
  }
  return num &gt; 1;
}

console.log([4, 6, 8, 9, 12].findIndex(isPrime)); // -1, not found
console.log([4, 6, 7, 9, 12].findIndex(isPrime)); // 2 (array[2] is 7)
</pre>

<h3 id="Find_index_using_arrow_function">Find index using arrow function</h3>

<p>The following example finds the index of a fruit using an arrow function:</p>

<pre class="brush: js">const fruits = ["apple", "banana", "cantaloupe", "blueberries", "grapefruit"];

const index = fruits.findIndex(fruit =&gt; fruit === "blueberries");

console.log(index); // 3
console.log(fruits[index]); // blueberries
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.findindex', 'Array.prototype.findIndex')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.findIndex")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.find()")}}</li>
 <li>{{jsxref("Array.prototype.indexOf()")}}</li>
</ul>
